unit macrsubs;

interface
uses classes, SysUtils;
type

TDataProcedure = procedure of object;

TMacroSubstitutionItem = class
public
  dataprocedure : TDataProcedure;
  name : String;
end;

TMacroSubstitution = class
private
  List : TList;
  function GetMacroSubstitutionItem(value : Integer) : TMacroSubstitutionItem;
public
  constructor Create;
  destructor Destroy; override;
  procedure Add(Name : String; dataprocedure : TDataProcedure);
  procedure Clear;
  function Count : Integer;
  function GetByName(value : String) : TMacroSubstitutionItem;
  function IndexOf(value : TMacroSubstitutionItem) : Integer;
  property Items[Index : Integer] : TMacroSubstitutionItem   read GetMacroSubstitutionItem;
end;

implementation
{TMacroSubstitution}
constructor TMacroSubstitution.Create;
begin
  inherited;
  List := TList.Create;
end;

destructor TMacroSubstitution.Destroy;
begin
  Clear;
  List.Free;
  inherited;
end;

procedure TMacroSubstitution.Add(Name : String; dataprocedure : TDataProcedure);
begin
  List.Add(TMacroSubstitutionItem.Create);
  Items[Count - 1].Name := Name;
  Items[Count - 1].dataprocedure := dataprocedure;
end;

procedure TMacroSubstitution.Clear;
Var
  i : Integer;
begin
  for i := 0 to Count -1 do
    Items[i].Free;
  List.Clear;  
end;

function TMacroSubstitution.Count : Integer;
begin
  Result := List.Count;
end;

function TMacroSubstitution.GetByName(value : String) : TMacroSubstitutionItem;
var
  i : Integer;
begin
  Result := Nil;
  for i := 0 to Count -1 do
    if(CompareText(value, Items[i].Name) = 0) then begin
      Result := Items[i];
      Break;
    end;
end;

function TMacroSubstitution.IndexOf(value : TMacroSubstitutionItem) : Integer;
begin
  Result := List.IndexOf(Value);
end;

function TMacroSubstitution.GetMacroSubstitutionItem(value : Integer) : TMacroSubstitutionItem;
begin
  result := Nil;
  if(Value > -1) and (value < Count) then
    result := TMacroSubstitutionItem(List[Value]);
end;


end.
